from typing import List
from pyVmomi import eam, vim, vmodl


class DisabledClusterFault(EamAppFault):
    @property
    def disabledComputeResource(self) -> List[vim.ComputeResource]: ...


class EamAppFault(EamRuntimeFault): ...


class EamFault(vmodl.MethodFault): ...


class EamIOFault(EamRuntimeFault): ...


class EamRuntimeFault(vmodl.RuntimeFault): ...


class EamServiceNotInitialized(EamRuntimeFault): ...


class EamSystemFault(EamRuntimeFault): ...


class InvalidAgencyScope(EamFault):
    @property
    def unknownComputeResource(self) -> List[vim.ComputeResource]: ...


class InvalidAgentConfiguration(EamFault):
    @property
    def invalidAgentConfiguration(self) -> eam.Agent.ConfigInfo: ...
    @property
    def invalidField(self) -> str: ...


class InvalidLogin(EamRuntimeFault): ...


class InvalidState(EamAppFault): ...


class InvalidUrl(EamFault):
    @property
    def url(self) -> str: ...
    @property
    def malformedUrl(self) -> bool: ...
    @property
    def unknownHost(self) -> bool: ...
    @property
    def connectionRefused(self) -> bool: ...
    @property
    def responseCode(self) -> int: ...


class InvalidVibPackage(EamRuntimeFault): ...


class NoConnectionToVCenter(EamRuntimeFault): ...


class NotAuthorized(EamRuntimeFault): ...