from typing import List
from pyVmomi import vim, vmodl


class ExtendedProductInfo(vmodl.DynamicData):
    @property
    def companyUrl(self) -> str: ...
    @property
    def productUrl(self) -> str: ...
    @property
    def managementUrl(self) -> str: ...
    @property
    def self(self) -> vim.ManagedEntity: ...


class ManagedByInfo(vmodl.DynamicData):
    @property
    def extensionKey(self) -> str: ...
    @property
    def type(self) -> str: ...


class ManagedEntityInfo(vmodl.DynamicData):
    @property
    def type(self) -> str: ...
    @property
    def smallIconUrl(self) -> str: ...
    @property
    def iconUrl(self) -> str: ...
    @property
    def description(self) -> str: ...


class SolutionManagerInfo(vmodl.DynamicData):
    @property
    def tab(self) -> List[SolutionManagerInfo.TabInfo]: ...
    @property
    def smallIconUrl(self) -> str: ...


    class TabInfo(vmodl.DynamicData):
        @property
        def label(self) -> str: ...
        @property
        def url(self) -> str: ...